/**********************************************************************
 *** entêtes pour le TP3 d'info-614 : RC4, WEP et attaque FMS         * ***
 Pierre Hyvernat                                                  *
 **********************************************************************/

#ifndef _tp3_H
#define _tp3_H

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>


typedef unsigned char octet;

/*****************
 * fichier rc4.c *
 *****************/

/* fonction auxiliaire : échange deux octets */
void echange(octet *a, octet *b) ;


/* la taille de la clé */
/* ATTENTION : pour les clés WEP, la taille comprends les octets des vecteurs
 * d'initialisation. Pour le WEP normal, "taille_cle" est donc de 16, meme si
 * la clé WEP elle même ne fait que 13 octets. */
extern int taille_cle;

/* génère une clé secrète aléatoire */
void nouvelle_cle_aleatoire() ;

/* le "key scheduling algorithm" : initialisation de l'état */
void RC4_KSA();

/* générer un nouvel octet à partir de l'état courant */
octet RC4_PRGA(void);

/* une fonction de test pour vérifier que les fonctions de RC4 font ce qu'il
 * faut. */
void test_RC4(void);



/***********************
 * modélisation du WEP *
 ***********************/

/* la taille des vecteurs d'initialisation */
extern int taille_IV;

/* génère une clé WEP aléatoire */
void nouvelle_cle_wep_aleatoire() ;

/* initialise une clé secrèt à partir d'un vecteur d'initialisation et de la
 * clé WEP */
void init_WEP_RC4(octet *IV);


/**********************************
 * fichier tp3-crack-nom-prenom.c *
 **********************************/

/**********************************************************************
 * devine le "n"-ième octet de la clé (en supposant qu'on connait les *
 * n-1 octets précédents) en essayant tous les vecteurs               *
 * d'initialisations faibles.                                         *
 * L'argument "cle_wep_partielle" contient le début de la clé (octets *
 * 0 à "n"-1, non compris).                                           *
 * La fonction ne modifie pas les "n"-1 premieres valeurs de          *
 * "cle_wep_partielle".                                               *
 *                                                                    *
 * L'argument "nb_IV_faibles" est le nombre de vecteurs faibles à     *
 * considérer.                                                        *
 * L'argument "nb_IV_total" est le nombre total de vecteurs à tester. *
 *                                                                    *
 * La fonction s'arrete quand l'une des deux bornes est atteinte.     *
 *                                                                    *
 * Si les 2 bornes sont nulles, on utilise alors uniquement la        *
 * famille de vecteurs (n+3, 255, ...). ATTENTION, ca n'est possible  *
 * que si "taille_IV = 3".                                            *
 *                                                                    *
 * La fonction renvoie "n" si l'opération c'est bien passée. Dans ce  *
 * cas, l'octet "n"-1 de "cle_wep_partielle" est positionné à sa      *
 * valeur.                                                            *
 *                                                                    *
 * La fonction renvoie "-1" en cas de problème. La "n"-ieme valeur de *
 * "cle_wep_partielle" est alors quelconque.                          *
 **********************************************************************/
int predit_octet (int n, octet *cle_wep_partielle, int nb_IV_faibles, int nb_IV_total) ;

#endif  /* _tp3_H */

